# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc重复删除需求单,2250,2250-8,sit,bs
主数据平台:运营后台管理系统需求单删除接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import json


module = "cmdc_demand_delete"


# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username")
password = commonFuc().get_business_data(module, "password")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 进行需求单创建
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url_demand")
request_body = commonFuc().get_business_data(module, "payload_demand")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 进行需求单查询
sql = "SELECT t.demandCode FROM `cmdc-order`.tc_demand t ORDER BY createTime DESC LIMIT 101"
demand_code = mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]
sql = "UPDATE `cmdc-order`.tc_demand t SET t.orderStatus = 99 WHERE t.demandCode = '{}'".format(demand_code)
mysql_handle.executeUpdate(host, port, user, pwd, "cmdc-order", sql)


# 第二步查询需求单列表中待首营的需求单
url1 = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url1")
request_body = commonFuc().get_business_data(module, "payload10")
# 发送请求
result = requests.post(url1, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
# 获取demandId
demand_id = result["data"]["list"][0]["demandId"]
# print(demand_id)
# 第三步删除操作
url2 = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url")
request_body2 = commonFuc().get_business_data(module, "payload1", demand_id)
# 发送请求
result2 = requests.post(url2, json=request_body2, headers=headers)

# 第四步重复进行删除操作
url3 = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url")
# print(url3)
request_body3 = commonFuc().get_business_data(module, "payload3", demand_id)
# print(request_body3)

"""
 场景:重复删除需求单
 用例名称：重复删除需求单
 输出：{"success":false,"code":"demand","data":null,"freshToken":null}
"""

# 发送请求
result3 = requests.post(url3, json=request_body3, headers=headers)
result3 = json.loads(result3.content)
# print(result)
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict4")
print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result3)
