# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_商品黑名单,2271,2271-26,sit,bs
主数据平台:后台运营系统返利规则商品黑名单查询接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取返利规则
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url3")
request_body = commonFuc().get_business_data(module, "payload3")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
# 生成一个随机数
rebate_random = random.randint(0, len(result["data"]["list"]) - 1)

# 获取返利规则信息
rebate_id = result["data"]["list"][rebate_random]["rebateid"]

# 第三步获取商品黑名单
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url11")
request_body = commonFuc().get_business_data(module, "payload11", rebate_id)
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
if result["data"]["list"]:
    # 生成一个随机数字，用于后续随机选择商品
    product_random = random.randint(0, len(result["data"]["list"]) - 1)
    # 获取商品黑名单中商品信息
    product_name = result["data"]["list"][product_random]["productname"]
    product_code = result["data"]["list"][product_random]["productcode"]
    specifications = result["data"]["list"][product_random]["specifications"]
    manufacturer = result["data"]["list"][product_random]["manufacturer"]

    # 第四步进行条件查询验证
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url12")
    request_body = commonFuc().get_business_data(module, "payload12", rebate_id, product_name, product_code, specifications,
                                                 manufacturer)
    """
    
     场景: 验证商品黑名单列表查询条件是否可以正常使用
     用例名称：列表查询条件验证_商品黑名单
     输出：{"productname":"%s"}
    """

    # 发送请求
    result = requests.post(url, json=request_body, headers=headers)
    result = json.loads(result.content)
    # print(result)
    # 获取查询结果中商品对应的商品名称
    result = {"productname": result["data"]["list"][0]["productname"]}
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict12", product_name)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
else:
    result = {"list": result["data"]["list"]}
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict12_1")
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)